<app-loading *ngIf="isLoading"></app-loading>
<div class="content-header">
  <div class="button-init">
    <mb-button
      mbButtonSize="VERY_LARGE"
      mbButtonAvailableStyle="PRIMARY"
      (click)="clickInit()"
      mbButtonText="Thêm mới"
    ></mb-button>
  </div>
</div>
<div nz-row class="cotainer-init-screen">
  <div
    nz-col
    nz-resizable
    (nzResize)="onResizeMatDraw($event)"
    [nzMinColumn]="5"
    [nzMaxColumn]="16"
    [nzGridColumnCount]="24"
    [nzSpan]="colMatDraw"
    class="cotainer-init-screen__left-content"
  >
    <nz-resize-handles></nz-resize-handles>
    <app-mb-tree [param]="params" [objFunction]="objFunction"></app-mb-tree>
  </div>
  <div nz-col [nzSpan]="24 - colMatDraw" class="cotainer-init-screen__right-content">
    <nz-card class="main-model-organization-card">
      <div nz-row class="main-model-organization-card__row">
        <div nz-col nzSpan="8" class="main-model-organization-card__left">
          <div style="position: relative">
            <mb-input-text
              [(ngModel)]="orgName"
              mbType="default"
              [mbMaxLength]="50"
              [defaultInput]="true"
              (mbClick)="showModalOrg($event)"
              mbPlaceholderText="{{ 'modelOrganization.initScreen.placeholder.chooseUnit' | translate }}"
              mbLabelText="{{ 'modelOrganization.initScreen.label.orgName' | translate }}"
              [mbReadOnly]="true"
            >
            </mb-input-text>
            <em
              *ngIf="orgName"
              nz-icon
              class="main-model-organization-card__left__icon"
              (click)="clearOrgInput()"
              nzType="close-circle"
              nzTheme="outline"
            ></em>
          </div>
        </div>
        <div nz-col nzSpan="8" class="main-model-organization-card__right">
          <mb-select
            [mbDataSelects]="listStatus"
            mbKeyLabel="label"
            mbKeyValue="value"
            mbLabelText="{{ 'modelOrganization.initScreen.label.status' | translate }} "
            mbPlaceholder="{{ 'modelOrganization.initScreen.placeholder.chooseStatus' | translate }}"
            [mbOptionHeightPx]="58"
            ngModel=""
            (mbSelect)="selectStatus($event)"
          ></mb-select>
        </div>
        <div nz-col nzSpan="8" class="main-model-organization-card__left">
          <mb-select
            [mbDataSelects]="listType"
            mbKeyLabel="label"
            mbKeyValue="value"
            mbLabelText="{{ 'modelOrganization.initScreen.label.type' | translate }}"
            mbPlaceholder="{{ 'modelOrganization.initScreen.placeholder.chooseType' | translate }}"
            [mbOptionHeightPx]="58"
            ngModel=""
            (mbSelect)="selectType($event)"
          ></mb-select>
        </div>
        <div
          nz-col
          nzSpan="24"
          class="main-model-organization-card__left"
          style="display: flex; justify-content: center; align-items: center"
        >
          <div class="main-model-organization-card__button-search">
            <mb-button
              mbButtonSize="VERY_LARGE"
              mbButtonAvailableStyle="CUSTOM"
              (click)="searchOrganization()"
              mbButtonText="{{ 'modelOrganization.initScreen.label.search' | translate }}"
            ></mb-button>
          </div>
          <div class="main-model-organization-card__button-excel">
            <mb-button
              *ngIf="objFunction.export"
              mbButtonType="BORDER"
              mbButtonSize="VERY_LARGE"
              (click)="exportExcel()"
            >
              <img src="../../../../../assets/images/icon/excel.svg" alt="" />
            </mb-button>
          </div>
        </div>
      </div>
    </nz-card>
    <nz-table
      class="table"
      #basicTable
      [nzData]="dataTable"
      [nzShowPagination]="false"
      [nzPageSize]="listSettingPaginationCustom.size"
      [nzScroll]="dataTable?.length > 0 ? { y: '390px' } : {}"
      nzTableLayout="fixed"
      [nzSize]="TABLE_SIZE"
    >
      <thead>
        <tr>
          <th scope="col" nzWidth="90px" nzLeft class="text-center">
            {{ 'modelOrganization.initScreen.table.label.stt' | translate }}
          </th>
          <th scope="col" nzWidth="400px" nzLeft>{{ 'modelOrganization.initScreen.table.label.orgName' | translate }}</th>
          <th scope="col" nzWidth="120px">{{ 'modelOrganization.initScreen.table.label.type' | translate }}</th>
          <th scope="col" class="text-center" nzWidth="180px">
            {{ 'modelOrganization.initScreen.table.label.status' | translate }}
          </th>
          <th scope="col" nzWidth="200px">{{ 'modelOrganization.initScreen.table.label.info' | translate }}</th>
          <th scope="col" nzWidth="120px">{{ 'modelOrganization.initScreen.table.label.date' | translate }}</th>
          <th scope="col" nzRight nzWidth="60px"></th>
        </tr>
      </thead>
      <tbody>
        <tr *ngFor="let data of basicTable.data; let i = index" (dblclick)='redrirectTo(data, true)'>
          <td nzLeft class="text-center">
            {{ i + 1 + listSettingPaginationCustom.size * listSettingPaginationCustom.pageIndex }}
          </td>
          <td
            nz-tooltip
            [nzTooltipTitle]="data.pathName"
            nzLeft
            class="organization-name">
            {{ data.pathName }}
          </td>
          <td>{{ renderType(data.inputType) }}</td>
          <td class="content-center">
            <nz-tag
              [class]="renderFlagStatus(data.flagStatus).class"
            >
            {{renderFlagStatus(data.flagStatus).text}}
            </nz-tag>
          </td>
          <td  nz-tooltip
               class="organization-name"
               [nzTooltipTitle]="data.content">
            {{ data.content }}
          </td>
          <td>
            <span style="display: flex; align-items: center" *ngIf="data.approveDate">
              {{ data.approveDate | date: 'dd/MM/yyyy' }}
            </span>
          </td>
          <td nzRight>
            <div class="main-model-organization__tooltip" *ngIf="data.flagStatus !== 0">
              <button mat-icon-button [matMenuTriggerFor]="menu" aria-label="Example icon-button with a menu"
              [disabled]="data.inputType === 'KT' && (data.flagStatus === 2 || data.flagStatus === 3
               ) && !objFunction.edit && !objFunction.delete">
                <mat-icon class="main-model-organization___tooltip__icon">more_vert</mat-icon>
              </button>
              <mat-menu #menu="matMenu" class="main-model-organization__tooltip__menu">
                <ng-container [ngSwitch]="data.flagStatus">
                  <ng-template [ngSwitchCase]="0"> </ng-template>
                  <ng-template [ngSwitchCase]="1">
                    <div
                      class="main-model-organization__tooltip__menu--item"
                      mat-menu-item
                      *ngIf="objFunction.view"
                      (click)="redirectToDetail(data.orgId)"
                    >
                      <img
                        alt=""
                        src="../../../../../assets/images/icon/information.svg"
                        width="20"
                        height="20"
                        class="selected-icon"
                      />
                      <span class="main-model-organization__tooltip__menu--item__text" nz-typography>{{
                        'modelOrganization.initScreen.label.detail' | translate
                      }}</span>
                    </div>
                  </ng-template>
                  <ng-template [ngSwitchCase]="2">
                    <div
                      class="main-model-organization__tooltip__menu--item"
                      mat-menu-item
                      (click)="redirectToDetail(data.orgId)"
                      *ngIf="data.inputType !== 'KT' && objFunction.view"
                    >
                      <img
                        alt=""
                        src="../../../../../assets/images/icon/information.svg"
                        width="20"
                        height="20"
                        class="selected-icon"
                      />
                      <span class="main-model-organization__tooltip__menu--item__text" nz-typography>{{
                        'modelOrganization.initScreen.label.detail' | translate
                      }}</span>
                    </div>
                    <mat-divider *ngIf="data.inputType !== 'KT' && objFunction.view"></mat-divider>
                    <div
                      class="main-model-organization__tooltip__menu--item"
                      (click)="redrirectTo(data, false, true)"
                      *ngIf="objFunction.edit"
                      mat-menu-item
                    >
                      <img
                        alt=""
                        src="../../../../../assets/images/icon/edit.png"
                        width="22"
                        height="15"
                        class="selected-icon"
                      />
                      <span class="main-model-organization__tooltip__menu--item__text" nz-typography>{{
                        'modelOrganization.initScreen.label.edit' | translate
                      }}</span>
                    </div>
                    <mat-divider *ngIf="data.inputType === 'KT'"></mat-divider>
                    <div
                      (click)="deleteOrg(data.orgId)"
                      *ngIf="data.inputType === 'KT' && objFunction.delete"
                      class="main-model-organization__tooltip__menu--item"
                      mat-menu-item
                    >
                      <mat-icon class="main-model-organization__tooltip__menu--item__icon">delete_outline </mat-icon>
                      <span class="main-model-organization__tooltip__menu--item__text" nz-typography>{{
                        'modelOrganization.initScreen.label.delete' | translate
                      }}</span>
                    </div>
                  </ng-template>
                  <ng-template [ngSwitchCase]="3">
                    <div
                      class="main-model-organization__tooltip__menu--item"
                      mat-menu-item
                      *ngIf="data.inputType !== 'KT' && objFunction.view"
                      (click)="redirectToDetail(data.orgId)"
                    >
                      <img
                        alt=""
                        src="../../../../../assets/images/icon/information.svg"
                        width="20"
                        height="20"
                        class="selected-icon"
                      />
                      <span class="main-model-organization__tooltip__menu--item__text" nz-typography>{{
                        'modelOrganization.initScreen.label.detail' | translate
                      }}</span>
                    </div>
                    <mat-divider *ngIf="data.inputType !== 'KT'"></mat-divider>
                    <div
                      class="main-model-organization__tooltip__menu--item"
                      (click)="redrirectTo(data, false, true)"
                      *ngIf="objFunction.edit"
                      mat-menu-item
                    >
                      <img
                        alt=""
                        src="../../../../../assets/images/icon/edit.png"
                        width="22"
                        height="15"
                        class="selected-icon"
                      />
                      <span class="main-model-organization__tooltip__menu--item__text" nz-typography>{{
                        'modelOrganization.initScreen.label.edit' | translate
                      }}</span>
                    </div>
                  </ng-template>
                  <ng-template [ngSwitchCase]="4">
                    <div
                      class="main-model-organization__tooltip__menu--item"
                      mat-menu-item
                      *ngIf="objFunction.view"
                      (click)="redirectToDetail(data.orgId)"
                    >
                      <img
                        alt=""
                        src="../../../../../assets/images/icon/information.svg"
                        width="20"
                        height="20"
                        class="selected-icon"
                      />
                      <span class="main-model-organization__tooltip__menu--item__text" nz-typography>{{
                        'modelOrganization.initScreen.label.detail' | translate
                      }}</span>
                    </div>
                  </ng-template>
                  <ng-template [ngSwitchCase]="6">
                    <div
                      class="main-model-organization__tooltip__menu--item"
                      mat-menu-item
                      *ngIf="objFunction.view"
                      (click)="redirectToDetail(data.orgId)"
                    >
                      <img
                        alt=""
                        src="../../../../../assets/images/icon/information.svg"
                        width="20"
                        height="20"
                        class="selected-icon"
                      />
                      <span class="main-model-organization__tooltip__menu--item__text" nz-typography>{{
                        'modelOrganization.initScreen.label.detail' | translate
                      }}</span>
                    </div>
                  </ng-template>
                </ng-container>
              </mat-menu>
            </div>
          </td>
        </tr>
      </tbody>
    </nz-table>
    <div class="pagination">
      <div *ngIf="listSettingPaginationCustom.total === 0; else elseTplNoti">
        <img class="pagination__table-info--icon" alt="" src="assets/images/icon/idea.svg" />
        <span class="pagination__table-info--text"> Tìm thấy {{ listSettingPaginationCustom.total }} kết quả </span>
      </div>
      <ng-template #elseTplNoti>
        <div class="pagination__table-info">
          <img alt="" class="pagination__table-info--icon" src="assets/images/icon/idea.svg" />
          <span class="pagination__table-info--text"
            >Tìm thấy {{ listSettingPaginationCustom.total }} kết quả, hiển thị từ
            {{ listSettingPaginationCustom.size * listSettingPaginationCustom.pageIndex + 1 }} đến
            {{
              listSettingPaginationCustom.size * listSettingPaginationCustom.pageIndex +
                listSettingPaginationCustom.numberOfElements
            }}</span
          >
        </div>
      </ng-template>
      <nz-pagination
        class="pagination__icon"
        [nzPageIndex]="listSettingPaginationCustom.pageIndex + 1"
        (nzPageIndexChange)="getListTemplateBasePagination($event)"
        [nzTotal]="listSettingPaginationCustom.total"
        [nzPageSize]="listSettingPaginationCustom.size"
      ></nz-pagination>
    </div>
  </div>
</div>
